//***********************************************************************
//
//  DlgCalc.h
//
//***********************************************************************

class CMyApp : public CWinApp
{
public:
    virtual BOOL InitInstance ();
};

class CCalcDialog : public CDialog
{
private:
    HACCEL m_hAccel;
    double m_dbStack[4];
    double m_dbMemory;
    CString m_strDisplay;
    CString m_strFormat;
    CRect m_rect;
    int m_cxChar;
    int m_cyChar;

    BOOL m_bFixPending;
    BOOL m_bErrorFlag;
    BOOL m_bDecimalInString;
    BOOL m_bStackLiftEnabled;
    BOOL m_bNewX;

    void LiftStack ();
    void DropStack ();
    void DisplayXRegister ();
    void UpdateDisplay (CString&);

public:
    CCalcDialog ();
    virtual BOOL OnInitDialog ();
    virtual BOOL PreTranslateMessage (MSG*);

protected:
    virtual BOOL OnCommand (WPARAM, LPARAM);
    virtual void OnCancel ();
    virtual void PostNcDestroy ();

    afx_msg void OnPaint ();
    afx_msg void OnSysCommand (UINT, LPARAM);
    afx_msg void OnDigit (UINT);
    afx_msg void OnAdd ();
    afx_msg void OnSubtract ();
    afx_msg void OnMultiply ();
    afx_msg void OnDivide ();
    afx_msg void OnEnter ();
    afx_msg void OnChangeSign ();
    afx_msg void OnExponent ();
    afx_msg void OnStore ();
    afx_msg void OnRecall ();
    afx_msg void OnFix ();
    afx_msg void OnClear ();
    afx_msg void OnDecimal ();
    afx_msg void OnDelete ();

    DECLARE_MESSAGE_MAP ()
};

class CAboutDialog : public CDialog
{
private:
    CRect m_rect;

public:
    CAboutDialog (CWnd* pParentWnd = NULL) :
        CDialog (IDD_ABOUTDLG, pParentWnd) {}

    virtual BOOL OnInitDialog ();

protected:
    afx_msg void OnPaint ();
    DECLARE_MESSAGE_MAP ()
};
